#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stddef.h>
#include <time.h>
#include <math.h>
#include <ctype.h>
#include <Windows.h>
#include "stdafx.h"
#include <stdio.h>
#include <errno.h>  
#include <fcntl.h>

/*************************************************************************
ڲ궨
*************************************************************************/


/*************************************************************************
ڲṹö١Ƚṹ
*************************************************************************/

/*************************************************************************
ڲ̬

ȫֱ

extern ⲿ

*************************************************************************/
static uint32 s_uiDecodeCnt = 0;


/*************************************************************************
̬

extern ⲿ
*************************************************************************/
typedef int32 (*tx_scanner_decode_data_cb_fun)(uint8 ucCodeType, uint8 *pBuf, uint32 uiBufLen);
typedef void  (*tx_scanner_comm_state_cb_fun)(uint8 ucState);

typedef int32 (*ptx_scanner_init)(void);
typedef int32 (*ptx_scanner_uart_open)(TS_UART_T tUart);
typedef int32 (*ptx_scanner_uart_close)(void);
typedef int32 (*ptx_scanner_deinit)(void);
typedef int32 (*ptx_scanner_get_version)(uint8 *pVer, uint8 ucVerLen);
typedef int32 (*ptx_scanner_decode_data_fun_register)(tx_scanner_decode_data_cb_fun fDataFun);
typedef int32 (*ptx_scanner_comm_state_fun_register)(tx_scanner_comm_state_cb_fun fStateFun);
typedef int32 (*ptx_scanner_get_version_info)(uint8 *pucVerInfo, uint16 usLen);
typedef int32 (*ptx_scanner_get_all_product_info)(uint8 *pucProInfo, uint16 usLen);
typedef int32 (*ptx_scanner_decode_start)(void);
typedef int32 (*ptx_scanner_decode_stop)(void);
typedef int32 (*ptx_scanner_no_time_decode_start)(void);
typedef int32 (*ptx_scanner_set_trigger_mode)(DB_TRIGGER_MODE_E eMode, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_trigger_mode)(void);
typedef int32 (*ptx_scanner_set_light_state)(DB_LED_STATE_E eLedState, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_light_state)(void);
typedef int32 (*ptx_scanner_set_en_prefix)(uint8 ucEnable, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_en_prefix)(void);
typedef int32(*ptx_scanner_set_prefix)(uint8 *pData, uint8 ucDataLen, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_prefix)(uint8 *pData, uint8 ucDataLen);
typedef int32 (*ptx_scanner_set_en_suffix)(uint8 ucEnable, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_en_suffix)(void);
typedef int32(*ptx_scanner_set_suffix)(uint8 *pData, uint8 ucDataLen, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_suffix)(uint8 *pData, uint8 ucDataLen);
typedef int32 (*ptx_scanner_set_focus_state)(DB_LED_STATE_E eLedState, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_focus_state)(void);
typedef int32 (*ptx_scanner_set_once_scan_time)(uint16 usTimeMs, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_once_scan_time)(void);
typedef int32 (*ptx_scanner_set_beep_volume)(uint8 ucVol, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_beep_volume)(void);
typedef int32 (*ptx_scanner_set_heartbeat_type)(DB_HEARTBEAT_TYPE_E eType, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_heartbeat_type)(void);
typedef int32 (*ptx_scanner_reset)(void);
typedef int32 (*ptx_scanner_scan_sw)(uint8 ucEnable);
typedef int32 (*ptx_scanner_cmd_setcode_sw)(uint8 ucEnable, uint8 isSaveParam);
typedef int32 (*ptx_scanner_set_heartbeat_gap_time)(uint32 uiTimeMs, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_heartbeat_gap_time)(void);
typedef int32 (*ptx_scanner_set_heartbeat_wait_ack_time)(uint32 uiTimeMs, uint8 isSaveParam);
typedef int32 (*ptx_scanner_get_heartbeat_wait_ack_time)(void);
typedef int32 (*ptx_scanner_get_image)(uint8 *pImageData, uint32 uiImageSize);
typedef int32 (*ptx_scanner_get_image_info)(uint8 *ucImageInfo, uint16 usLen);

ptx_scanner_init tx_scanner_init;
ptx_scanner_uart_open tx_scanner_uart_open;
ptx_scanner_uart_close tx_scanner_uart_close;
ptx_scanner_deinit tx_scanner_deinit;
ptx_scanner_get_version tx_scanner_get_version;
ptx_scanner_decode_data_fun_register tx_scanner_decode_data_fun_register;
ptx_scanner_comm_state_fun_register tx_scanner_comm_state_fun_register;
ptx_scanner_get_version_info tx_scanner_get_version_info;
ptx_scanner_get_all_product_info tx_scanner_get_all_product_info;
ptx_scanner_decode_start tx_scanner_decode_start;
ptx_scanner_decode_stop tx_scanner_decode_stop;
ptx_scanner_no_time_decode_start tx_scanner_no_time_decode_start;
ptx_scanner_set_trigger_mode tx_scanner_set_trigger_mode;
ptx_scanner_get_trigger_mode tx_scanner_get_trigger_mode;
ptx_scanner_set_light_state tx_scanner_set_light_state;
ptx_scanner_get_light_state tx_scanner_get_light_state;
ptx_scanner_set_en_prefix tx_scanner_set_en_prefix;
ptx_scanner_get_en_prefix tx_scanner_get_en_prefix;
ptx_scanner_set_prefix tx_scanner_set_prefix;
ptx_scanner_get_prefix tx_scanner_get_prefix;
ptx_scanner_set_en_suffix tx_scanner_set_en_suffix;
ptx_scanner_get_en_suffix tx_scanner_get_en_suffix;
ptx_scanner_set_suffix tx_scanner_set_suffix;
ptx_scanner_get_suffix tx_scanner_get_suffix;
ptx_scanner_set_focus_state tx_scanner_set_focus_state;
ptx_scanner_get_focus_state tx_scanner_get_focus_state;
ptx_scanner_set_once_scan_time tx_scanner_set_once_scan_time;
ptx_scanner_get_once_scan_time tx_scanner_get_once_scan_time;
ptx_scanner_set_beep_volume tx_scanner_set_beep_volume;
ptx_scanner_get_beep_volume tx_scanner_get_beep_volume;
ptx_scanner_set_heartbeat_type tx_scanner_set_heartbeat_type;
ptx_scanner_get_heartbeat_type tx_scanner_get_heartbeat_type;
ptx_scanner_reset tx_scanner_reset;
ptx_scanner_scan_sw tx_scanner_scan_sw;
ptx_scanner_cmd_setcode_sw tx_scanner_cmd_setcode_sw;
ptx_scanner_set_heartbeat_gap_time tx_scanner_set_heartbeat_gap_time;
ptx_scanner_get_heartbeat_gap_time tx_scanner_get_heartbeat_gap_time;
ptx_scanner_set_heartbeat_wait_ack_time tx_scanner_set_heartbeat_wait_ack_time;
ptx_scanner_get_heartbeat_wait_ack_time tx_scanner_get_heartbeat_wait_ack_time;
ptx_scanner_get_image tx_scanner_get_image;
ptx_scanner_get_image_info tx_scanner_get_image_info;

/**ݻص**/
static int32 tx_scanner_sdk_decode_data_cb(uint8 ucCodeType, uint8 *pBuf, uint32 uiBufLen);
/**״̬ص**/
static void tx_scanner_sdk_comm_state_cb_fun(uint8 ucState);
static int32 tx_scanner_sdk_save_raw(const char* pFilePath, const uint8* pImageData, int32 iImageSize);
static int32 tx_scanner_sdk_save_bmp(const char* pFilePath,uint8 *pImageData, int16 sImageWidth, int16 sImageHeight);
static int32 tx_scanner_sdk_bmp_write_data(const char* pFilePath,uint8 *pImageData, int32 iBytes);

/*************************************************************************

*************************************************************************/
int32 main(int argc, _TCHAR* argv[])
{
	int32 iRet;
	uint8 ucVer[64] = "";
	uint8 ucTemp1;
	uint8 ucTemp2;
	uint32 uiTemp3;
	char cInput[256];
	uint8 cTemp[128];
	uint8 uiLen = 0;
	int i=0;
	TS_UART_T tUart;

	HINSTANCE hInstLibrary = LoadLibrary("..\\..\\..\\lib\\tx_windows_uart.dll");//.dll
	if(NULL == hInstLibrary)
	{
		FreeLibrary(hInstLibrary);
		printf("open dll error\r\n");
	}

	tx_scanner_init = (ptx_scanner_init)GetProcAddress(hInstLibrary, "tx_scanner_init");//ڶΪҪõĺ
	if(tx_scanner_init == NULL)
		printf("tx_scanner_init error: %d\r\n", GetLastError());

	tx_scanner_uart_open = (ptx_scanner_uart_open)GetProcAddress(hInstLibrary, "tx_scanner_uart_open");//ڶΪҪõĺ
	if(tx_scanner_uart_open == NULL)
		printf("tx_scanner_uart_open error: %d\r\n", GetLastError());

	tx_scanner_uart_close = (ptx_scanner_uart_close)GetProcAddress(hInstLibrary, "tx_scanner_uart_close");//ڶΪҪõĺ
	if(tx_scanner_uart_close == NULL)
		printf("tx_scanner_uart_close error: %d\r\n", GetLastError());

	tx_scanner_deinit = (ptx_scanner_deinit)GetProcAddress(hInstLibrary, "tx_scanner_deinit");//ڶΪҪõĺ
	if(tx_scanner_deinit == NULL)
		printf("tx_scanner_deinit error: %d\r\n", GetLastError());

	tx_scanner_get_version = (ptx_scanner_get_version)GetProcAddress(hInstLibrary, "tx_scanner_get_version");//ڶΪҪõĺ
	if(tx_scanner_get_version == NULL)
		printf("tx_scanner_get_version error: %d\r\n", GetLastError());

	tx_scanner_decode_data_fun_register = (ptx_scanner_decode_data_fun_register)GetProcAddress(hInstLibrary, "tx_scanner_decode_data_fun_register");//ڶΪҪõĺ
	if(tx_scanner_decode_data_fun_register == NULL)
		printf("tx_scanner_decode_data_fun_register error: %d\r\n", GetLastError());

	tx_scanner_comm_state_fun_register = (ptx_scanner_comm_state_fun_register)GetProcAddress(hInstLibrary, "tx_scanner_comm_state_fun_register");//ڶΪҪõĺ
	if (tx_scanner_comm_state_fun_register == NULL)
		printf("tx_scanner_comm_state_fun_register error: %d\r\n", GetLastError());

	tx_scanner_get_version_info = (ptx_scanner_get_version_info)GetProcAddress(hInstLibrary, "tx_scanner_get_version_info");//ڶΪҪõĺ
	if(tx_scanner_get_version_info == NULL)
		printf("tx_scanner_get_version_info error: %d\r\n", GetLastError());

	tx_scanner_get_all_product_info = (ptx_scanner_get_all_product_info)GetProcAddress(hInstLibrary, "tx_scanner_get_all_product_info");//ڶΪҪõĺ
	if(tx_scanner_get_all_product_info == NULL)
		printf("tx_scanner_get_all_product_info error: %d\r\n", GetLastError());

	tx_scanner_decode_start = (ptx_scanner_decode_start)GetProcAddress(hInstLibrary, "tx_scanner_decode_start");//ڶΪҪõĺ
	if(tx_scanner_decode_start == NULL)
		printf("tx_scanner_decode_stop error: %d\r\n", GetLastError());

	tx_scanner_decode_stop = (ptx_scanner_decode_stop)GetProcAddress(hInstLibrary, "tx_scanner_decode_stop");//ڶΪҪõĺ
	if(tx_scanner_decode_stop == NULL)
		printf("tx_scanner_decode_stop error: %d\r\n", GetLastError());

	tx_scanner_no_time_decode_start = (ptx_scanner_no_time_decode_start)GetProcAddress(hInstLibrary, "tx_scanner_no_time_decode_start");//ڶΪҪõĺ
	if(tx_scanner_no_time_decode_start == NULL)
		printf("tx_scanner_no_time_decode_start error: %d\r\n", GetLastError());

	tx_scanner_set_trigger_mode = (ptx_scanner_set_trigger_mode)GetProcAddress(hInstLibrary, "tx_scanner_set_trigger_mode");//ڶΪҪõĺ
	if(tx_scanner_set_trigger_mode == NULL)
		printf("ts_scan_set_en_sign error: %d\r\n", GetLastError());

	tx_scanner_get_trigger_mode = (ptx_scanner_get_trigger_mode)GetProcAddress(hInstLibrary, "tx_scanner_get_trigger_mode");//ڶΪҪõĺ
	if(tx_scanner_get_trigger_mode == NULL)
		printf("tx_scanner_get_trigger_mode error: %d\r\n", GetLastError());

	tx_scanner_set_light_state = (ptx_scanner_set_light_state)GetProcAddress(hInstLibrary, "tx_scanner_set_light_state");//ڶΪҪõĺ
	if(tx_scanner_set_light_state == NULL)
		printf("tx_scan_sw error: %d\r\n", GetLastError());

	tx_scanner_get_light_state = (ptx_scanner_get_light_state)GetProcAddress(hInstLibrary, "tx_scanner_get_light_state");//ڶΪҪõĺ
	if(tx_scanner_get_light_state == NULL)
		printf("tx_scanner_get_light_state error: %d\r\n", GetLastError());

	tx_scanner_set_en_prefix = (ptx_scanner_set_en_prefix)GetProcAddress(hInstLibrary, "tx_scanner_set_en_prefix");//ڶΪҪõĺ
	if(tx_scanner_set_en_prefix == NULL)
		printf("tx_scanner_set_en_prefix error: %d\r\n", GetLastError());
	
	tx_scanner_get_en_prefix = (ptx_scanner_get_en_prefix)GetProcAddress(hInstLibrary, "tx_scanner_get_en_prefix");//ڶΪҪõĺ
	if(tx_scanner_get_en_prefix == NULL)
		printf("tx_scanner_get_en_prefix error: %d\r\n", GetLastError());

	tx_scanner_set_prefix = (ptx_scanner_set_prefix)GetProcAddress(hInstLibrary, "tx_scanner_set_prefix");//ڶΪҪõĺ
	if (tx_scanner_set_prefix == NULL)
		printf("tx_scanner_set_prefix error: %d\r\n", GetLastError());

	tx_scanner_get_prefix = (ptx_scanner_get_prefix)GetProcAddress(hInstLibrary, "tx_scanner_get_prefix");//ڶΪҪõĺ
	if (tx_scanner_get_prefix == NULL)
		printf("tx_scanner_get_prefix error: %d\r\n", GetLastError());

	tx_scanner_set_en_suffix = (ptx_scanner_set_en_suffix)GetProcAddress(hInstLibrary, "tx_scanner_set_en_suffix");//ڶΪҪõĺ
	if(tx_scanner_set_en_suffix == NULL)
		printf("tx_scanner_set_en_suffix error: %d\r\n", GetLastError());

	tx_scanner_get_en_suffix = (ptx_scanner_get_en_suffix)GetProcAddress(hInstLibrary, "tx_scanner_get_en_suffix");//ڶΪҪõĺ
	if(tx_scanner_get_en_suffix == NULL)
		printf("tx_scanner_get_en_suffix error: %d\r\n", GetLastError());
	
	tx_scanner_set_suffix = (ptx_scanner_set_suffix)GetProcAddress(hInstLibrary, "tx_scanner_set_suffix");//ڶΪҪõĺ
	if (tx_scanner_set_suffix == NULL)
		printf("tx_scanner_set_suffix error: %d\r\n", GetLastError());

	tx_scanner_get_suffix = (ptx_scanner_get_suffix)GetProcAddress(hInstLibrary, "tx_scanner_get_suffix");//ڶΪҪõĺ
	if (tx_scanner_get_suffix == NULL)
		printf("tx_scanner_get_suffix error: %d\r\n", GetLastError());
	
	tx_scanner_set_focus_state = (ptx_scanner_set_focus_state)GetProcAddress(hInstLibrary, "tx_scanner_set_focus_state");//ڶΪҪõĺ
	if (tx_scanner_set_focus_state == NULL)
		printf("tx_scanner_set_focus_state error: %d\r\n", GetLastError());

	tx_scanner_get_focus_state = (ptx_scanner_get_focus_state)GetProcAddress(hInstLibrary, "tx_scanner_get_focus_state");//ڶΪҪõĺ
	if (tx_scanner_get_focus_state == NULL)
		printf("tx_scanner_get_focus_state error: %d\r\n", GetLastError());

	tx_scanner_set_once_scan_time = (ptx_scanner_set_once_scan_time)GetProcAddress(hInstLibrary, "tx_scanner_set_once_scan_time");//ڶΪҪõĺ
	if (tx_scanner_set_once_scan_time == NULL)
		printf("tx_scanner_set_once_scan_time error: %d\r\n", GetLastError());

	tx_scanner_get_once_scan_time = (ptx_scanner_get_once_scan_time)GetProcAddress(hInstLibrary, "tx_scanner_get_once_scan_time");//ڶΪҪõĺ
	if (tx_scanner_get_once_scan_time == NULL)
		printf("tx_scanner_get_once_scan_time error: %d\r\n", GetLastError());

	tx_scanner_set_beep_volume = (ptx_scanner_set_beep_volume)GetProcAddress(hInstLibrary, "tx_scanner_set_beep_volume");//ڶΪҪõĺ
	if (tx_scanner_set_beep_volume == NULL)
		printf("tx_scanner_set_once_scan_time error: %d\r\n", GetLastError());

	tx_scanner_get_beep_volume = (ptx_scanner_get_beep_volume)GetProcAddress(hInstLibrary, "tx_scanner_get_beep_volume");//ڶΪҪõĺ
	if (tx_scanner_get_beep_volume == NULL)
		printf("tx_scanner_get_beep_volume error: %d\r\n", GetLastError());

	tx_scanner_set_heartbeat_type = (ptx_scanner_set_heartbeat_type)GetProcAddress(hInstLibrary, "tx_scanner_set_heartbeat_type");//ڶΪҪõĺ
	if (tx_scanner_set_heartbeat_type == NULL)
		printf("tx_scanner_set_heartbeat_type error: %d\r\n", GetLastError());

	tx_scanner_get_heartbeat_type = (ptx_scanner_get_heartbeat_type)GetProcAddress(hInstLibrary, "tx_scanner_get_heartbeat_type");//ڶΪҪõĺ
	if (tx_scanner_get_heartbeat_type == NULL)
		printf("tx_scanner_get_heartbeat_type error: %d\r\n", GetLastError());
		
	tx_scanner_reset = (ptx_scanner_reset)GetProcAddress(hInstLibrary, "tx_scanner_reset");//ڶΪҪõĺ
	if(tx_scanner_reset == NULL)
		printf("tx_scanner_reset error: %d\r\n", GetLastError());

	tx_scanner_scan_sw = (ptx_scanner_scan_sw)GetProcAddress(hInstLibrary, "tx_scanner_scan_sw");//ڶΪҪõĺ
	if(tx_scanner_scan_sw == NULL)
		printf("tx_scanner_scan_sw error: %d\r\n", GetLastError());

	tx_scanner_cmd_setcode_sw = (ptx_scanner_cmd_setcode_sw)GetProcAddress(hInstLibrary, "tx_scanner_cmd_setcode_sw");//ڶΪҪõĺ
	if(tx_scanner_cmd_setcode_sw == NULL)
		printf("tx_scanner_cmd_setcode_sw error: %d\r\n", GetLastError());

	tx_scanner_set_heartbeat_gap_time = (ptx_scanner_set_heartbeat_gap_time)GetProcAddress(hInstLibrary, "tx_scanner_set_heartbeat_gap_time");//ڶΪҪõĺ
	if(tx_scanner_set_heartbeat_gap_time == NULL)
		printf("tx_scanner_set_heartbeat_gap_time error: %d\r\n", GetLastError());
	
	tx_scanner_get_heartbeat_gap_time = (ptx_scanner_get_heartbeat_gap_time)GetProcAddress(hInstLibrary, "tx_scanner_get_heartbeat_gap_time");//ڶΪҪõĺ
	if(tx_scanner_get_heartbeat_gap_time == NULL)
		printf("tx_scanner_get_heartbeat_gap_time error: %d\r\n", GetLastError());
	tx_scanner_set_heartbeat_wait_ack_time = (ptx_scanner_set_heartbeat_wait_ack_time)GetProcAddress(hInstLibrary, "tx_scanner_set_heartbeat_wait_ack_time");//ڶΪҪõĺ
	if(tx_scanner_set_heartbeat_wait_ack_time == NULL)
		printf("tx_scanner_set_heartbeat_wait_ack_time error: %d\r\n", GetLastError());
		
	tx_scanner_get_heartbeat_wait_ack_time = (ptx_scanner_get_heartbeat_wait_ack_time)GetProcAddress(hInstLibrary, "tx_scanner_get_heartbeat_wait_ack_time");//ڶΪҪõĺ
	if(tx_scanner_get_heartbeat_wait_ack_time == NULL)
		printf("tx_scanner_get_heartbeat_wait_ack_time error: %d\r\n", GetLastError());

	tx_scanner_get_image = (ptx_scanner_get_image)GetProcAddress(hInstLibrary, "tx_scanner_get_image");//ڶΪҪõĺ
	if (tx_scanner_get_image == NULL)
		printf("tx_scanner_get_image error: %d\r\n", GetLastError());

	tx_scanner_get_image_info = (ptx_scanner_get_image_info)GetProcAddress(hInstLibrary, "tx_scanner_get_image_info");//ڶΪҪõĺ
	if (tx_scanner_get_image_info == NULL)
		printf("tx_scanner_get_image_info error: %d\r\n", GetLastError());

	tx_scanner_get_version(ucVer, sizeof(ucVer));
	printf("windows c/c++ uart demo ver:%s\r\n", ucVer);

	/**עݻص**/
	iRet = tx_scanner_decode_data_fun_register(tx_scanner_sdk_decode_data_cb);
	if(iRet < 0)
	{
		printf("tx_scanner_decode_data_fun_register fail!!!\r\n");
		return 1;
	}

	/**ע豸״̬ص**/
	iRet = tx_scanner_comm_state_fun_register(tx_scanner_sdk_comm_state_cb_fun);
	if (iRet < 0)
	{
		printf("tx_scanner_comm_state_fun_register fail!!!\r\n");
		return 1;
	}
	
	tUart.ucCom[0] = 'C';
	tUart.ucCom[1] = 'O';
	tUart.ucCom[2] = 'M';
	tUart.ucCom[3] = '3';
	printf("Enter the configuration parameters. By default, press Enter\n");
	printf("Please enter serial port number(default: COM3)\n");
	fgets(cInput, sizeof(cInput), stdin);
	if(cInput[0] != '\n')
	{
		sscanf_s(cInput, "%s", tUart.ucCom);
	}

	tUart.eBaudrate = TS_BAUD_115200;
	printf("Please enter baud rate 0-13(default 10:115200)\n");
	printf("0:300\n");
	printf("1:600\n");
	printf("2:1200\n");
	printf("3:2400\n");
	printf("4:4800\n");
	printf("5:9600\n");
	printf("6:14400\n");
	printf("7:19200\n");
	printf("8:38400\n");
	printf("9:57600\n");
	printf("10:115200\n");
	printf("11:128000\n");
	printf("12:192000\n");
	printf("13:256000\n");
	fgets(cInput, sizeof(cInput), stdin);
	if(cInput[0] != '\n')
	{
		sscanf_s(cInput, "%d", &tUart.eBaudrate);
	}

	tUart.eDataBits = TS_DATA_BITS_8;
	printf("Please enter data bits 0-3(default 3:8-bit),(0:5-bit)(1:6-bit)(2:7-bit)(3:8-bit)\n");
	fgets(cInput, sizeof(cInput), stdin);
	if(cInput[0] != '\n')
	{
		sscanf_s(cInput, "%d", &tUart.eDataBits);
	}

	tUart.eStopBits = TS_STOP_BITS_1;
	printf("Please enter the stop bit 0-2(default 0:1-bit),(0:1-bit)(1:1.5-bit)(2:2-bit)\n");
	fgets(cInput, sizeof(cInput), stdin);
	if(cInput[0] != '\n')
	{
		sscanf_s(cInput, "%d", &tUart.eStopBits);
	}

	tUart.eParityBits = TS_PARITY_BITS_NONE;
	printf("Please enter a check digit 0-3(default 0:NONE),(0:NONE)(1:ODD)(2:EVEN)(3:MARK)(4:SPACE)\n");
	fgets(cInput, sizeof(cInput), stdin);
	if(cInput[0] != '\n')
	{
		sscanf_s(cInput, "%d", &tUart.eParityBits);
	}

	tUart.eFlowCtl = TS_FW_NONE;
	printf("Please enter a control flow 0-2(default 0:FW_NONE)(0:FW_NONE,1:HARDWARE,2:SOFTWARE)\r\n");
	fgets(cInput, sizeof(cInput), stdin);
	if (cInput[0]!= '\n');
	{
		sscanf_s(cInput,"%d", &tUart.eFlowCtl);
	}
	printf("******************************************************\r\n");

	/**ʼ**/
	iRet = tx_scanner_init();
	if(iRet < 0)
	{
		printf("tx_scanner_init fail!!!\r\n");
		return 1;
	}

	iRet = tx_scanner_uart_open(tUart);
	if(iRet < 0)
	{
		printf("tx_scanner_uart_open fail!!!\r\n");
		/**п**/
	    while (true)
		{
	        /**ȴûֶرп**/
	    }
	}

	printf("******************************************************\r\n");
	printf("a:start decode\r\n");
	printf("b:stop decode\r\n");
	printf("c:no time decode start\r\n");
	printf("d:get version info\r\n");
	printf("e:get product info\r\n");
	printf("f:set trigger mode; 0:LEVEL,1:PULSE,2:CONTINUOUS,3:AUTOSENS; save:0:no,1:yes.(eg:f01)\r\n");
	printf("g:get trigger mode\r\n");
	printf("h:set light LED; 0:working light,1:always off,2:always on; save:0:no,1:yes.(eg:h01)\r\n");
	printf("i:get light LED\r\n");
	printf("j:set prefix state; 0:OFF prefix,1:ON prefix; save:0:no,1:yes.(eg:j01)\r\n");
	printf("k:get prefix state\r\n");
	printf("l:set prefix parm;prefix by default:ABC(eg:l0)\r\n");
	printf("m:get prefix\r\n");
	printf("n:set suffix state; 0:OFF suffix,1:ON suffix; save:0:no,1:yes.(eg:n01)\r\n");
	printf("o:get suffix state\r\n");
	printf("p:set suffix parm;suffix by default:CBA(eg:p0)\r\n");
	printf("r:get suffix\r\n");
	printf("s:set light focus; 0:working light,1:always off,2:always on; save:0:no,1:yes.(eg:s01)\r\n");
	printf("t:get light focus\r\n");
	printf("u:set once scan time; from 0 to 65535ms; 0 indicates that there is no time limit; save:0:no,1:yes.(eg:u1000)+Enter+(eg:1)\r\n");
	printf("v:get once scan time\r\n");
	printf("w:set beep volume; from 0 to 100, 0: Silent; save:0:no,1:yes.(eg:w50)+Enter+(eg:1)\r\n");
	printf("x:get beep volume\r\n");
	printf("y:reset\r\n");
	printf("z:scan switch; 0:OFF, 1:ON\r\n");
	printf("1:setcode switch; 0:OFF, 1:ON; save:0:no,1:yes.(eg:101)\r\n");
	printf("2:set heartbeat; 0:Default,1:No need for ACK,2:need for ACK; save:0:no,1:yes.(eg:201)\r\n");
	printf("3:get heartbeat\r\n");
	printf("4:set heartbeat gap time; from 0 to 2147483648ms; save:0:no,1:yes.(eg:41000)+Enter+(eg:1)\r\n");
	printf("5:get heartbeat gap time\r\n");
	printf("6:set heartbeat wait ack time; from 0 to 2147483648ms; save:0:no,1:yes.(eg:61000)+Enter+(eg:1)\r\n");
	printf("7:get heartbeat wait ack time\r\n");
	printf("8:get image\r\n");
	printf("9:get image info\r\n");
	printf("q:quit\r\n");
	printf("******************************************************\r\n");
	while(1)
	{
		switch(getchar())
		{
			case 'a':
			case 'A':
				iRet = tx_scanner_decode_start();
				if(iRet < 0)
					printf("tx_scanner_decode_start fail!!!\r\n");
				else
					printf("start\r\n");
					
				break;

			case 'b':
			case 'B':
				iRet = tx_scanner_decode_stop();
				if(iRet < 0)
					printf("tx_scanner_decode_stop fail!!!\r\n");
				else
					printf("stop\r\n");
				break;

			case 'c':
			case 'C':
				iRet = tx_scanner_no_time_decode_start();
				if(iRet < 0)
					printf("tx_scanner_no_time_decode_start fail!!!\r\n");
				else
					printf("no time start\r\n");
				break;

			case 'd':
			case 'D':
				{
					uint8 ucVerInfo[128] = "";
				
					iRet = tx_scanner_get_version_info(ucVerInfo, sizeof(ucVerInfo));
					if(iRet < 0)
						printf("tx_scanner_get_version_info fail!!!\r\n");
					else
						printf("%s\r\n", ucVerInfo);
				}
				break;

			case 'e':
			case 'E':
				{
					uint8 ucProInfo[128] = "";
				
					iRet = tx_scanner_get_all_product_info(ucProInfo, sizeof(ucProInfo));
					if(iRet < 0)
						printf("tx_scanner_get_all_product_info fail!!!\r\n");
					else
						printf("%s\r\n", ucProInfo);
				}
				break;

			case 'f':
			case 'F':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_trigger_mode((DB_TRIGGER_MODE_E)ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_trigger_mode fail!!!\r\n");
				break;

			case 'g':
			case 'G':
				iRet = tx_scanner_get_trigger_mode();
				printf("tx_scanner_get_trigger_mode:%d\r\n", iRet);
				break;		

			case 'h':
			case 'H':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_light_state((DB_LED_STATE_E)ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("ts_scanner_set_light_state fail!!!\r\n");
				break;

			case 'i':
			case 'I':
				iRet = tx_scanner_get_light_state();
				printf("ts_scanner_get_light_state:%d\r\n", iRet);
				break;	

			case 'j':
			case 'J':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_en_prefix(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_prefix_state fail!!!\r\n");
				break;

			case 'k':
			case 'K':
				iRet = tx_scanner_get_en_prefix();
				printf("tx_scanner_get_en_prefix:%d\r\n", iRet);
				break;

			case 'l':
			case 'L':
				{
					ucTemp1 = getchar();
					ucTemp1 -= '0';
					printf("%d\r\n", ucTemp1);
					
					uint8 ucArr[] = "ABC";
					uiLen = strlen((char*)ucArr);

					iRet = tx_scanner_set_prefix(ucArr, uiLen,ucTemp1);
					if (iRet < 0)
						printf("tx_scanner_set_prefix fail!!!\r\n");
					break;
				}
			case 'm':
			case 'M':
				memset(cTemp,0,sizeof(cTemp));
				iRet = tx_scanner_get_prefix(cTemp, uiLen);
				printf("tx_scanner_get_prefix:%d\r\n", iRet);			
				break;

			case 'n':
			case 'N':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_en_suffix(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_en_suffix fail!!!\r\n");
				break;

			case 'o':
			case 'O':
				iRet = tx_scanner_get_en_suffix();
				printf("tx_scanner_get_en_suffix:%d\r\n", iRet);
				break;

			case 'p':
			case 'P':
				{
					ucTemp1 = getchar();
					ucTemp1 -= '0';
					printf("%d\r\n", ucTemp1);
					
					uint8 ucArr[] = "CBA";
					uiLen = strlen((char*)ucArr);

					iRet = tx_scanner_set_suffix(ucArr, uiLen,ucTemp1);
					if (iRet < 0)
						printf("tx_scanner_set_suffix fail!!!\r\n");
					break;
				}

			case 'r':
			case 'R':
				memset(cTemp,0,sizeof(cTemp));
				iRet = tx_scanner_get_suffix(cTemp, uiLen);
				printf("tx_scanner_get_suffix:%d\r\n", iRet);
				break;
			
			case 's':
			case 'S':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_focus_state((DB_LED_STATE_E)ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_focus_state fail!!!\r\n");
				break;

			case 't':
			case 'T':
				iRet = tx_scanner_get_focus_state();
				printf("tx_scanner_get_focus_state:%d\r\n", iRet);
				break;

			case 'u':
			case 'U':
				scanf_s("%d", &uiTemp3);
				getchar();
				ucTemp2 = getchar();
				ucTemp2 -= '0';
				printf("%d,%d\r\n", uiTemp3, ucTemp2);
				iRet = tx_scanner_set_once_scan_time((uint16)uiTemp3, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_suffix_state fail!!!\r\n");
				break;

			case 'v':
			case 'V':
				iRet = tx_scanner_get_once_scan_time();
				printf("tx_scanner_get_once_scan_time:%d\r\n", iRet);
				break;	

			case 'w':
			case 'W':
				scanf_s("%d", &ucTemp1);
				getchar();
				ucTemp2 = getchar();
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_beep_volume(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_beep_volume fail!!!\r\n");
				break;

			case 'x':
			case 'X':
				iRet = tx_scanner_get_beep_volume();
				printf("tx_scanner_get_beep_volume:%d\r\n", iRet);
				break;	

			case 'y':
			case 'Y':
				iRet = tx_scanner_reset();
				if(iRet < 0)
					printf("tx_scanner_reset fail!!!\r\n");
				else
					printf("reset\r\n");				
				break;

			case 'z':
			case 'Z':
				ucTemp1 = getchar();

				ucTemp1 -= '0';
				printf("%d\r\n", ucTemp1);
				iRet = tx_scanner_scan_sw(ucTemp1);
				if(iRet < 0)
					printf("tx_scanner_scan_sw fail!!!\r\n");
				break;

			case '1':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_cmd_setcode_sw(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_cmd_setcode_sw fail!!!\r\n");
				break;

			case '2':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_heartbeat_type((DB_HEARTBEAT_TYPE_E)ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_heartbeat_type fail!!!\r\n");
				break;

			case '3':
				iRet = tx_scanner_get_heartbeat_type();
				printf("tx_scanner_get_heartbeat_type:%d\r\n", iRet);
				break;	

			case '4':
				scanf_s("%d", &uiTemp3);
				getchar();
				ucTemp2 = getchar();
				ucTemp2 -= '0';
				iRet = tx_scanner_set_heartbeat_gap_time(uiTemp3, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_heartbeat_gap_time fail!!!\r\n");
				break;

			case '5':
				iRet = tx_scanner_get_heartbeat_gap_time();
				printf("tx_scanner_get_heartbeat_gap_time:%d\r\n", iRet);
				break;	

			case '6':
				scanf_s("%d", &uiTemp3);
				getchar();
				ucTemp2 = getchar();
				ucTemp2 -= '0';
				iRet = tx_scanner_set_heartbeat_wait_ack_time(uiTemp3, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_heartbeat_wait_ack_time fail!!!\r\n");
				break;

			case '7':
				iRet = tx_scanner_get_heartbeat_wait_ack_time();
				printf("tx_scanner_get_heartbeat_wait_ack_time:%d\r\n", iRet);
				break;	

			case '8':
			{
				uint8 ucImageData[640*480] = "";
				uint32 uiImageSize;
				
				uiImageSize = sizeof(ucImageData);
				iRet = tx_scanner_get_image(ucImageData, uiImageSize);
				if(iRet < 0)
				{
					printf("get image fail!!!\r\n");
					break;
				}
				else
				{
					iRet = tx_scanner_sdk_save_raw("image.raw", ucImageData, uiImageSize);
					if(iRet < 0)
					{
						printf("Error: Failed to create raw file!!!\n");
						break;
					}
					iRet = tx_scanner_sdk_save_bmp("image.bmp", ucImageData, 640, 480);
					if(iRet < 0)
					{
						printf("Error: Failed to create bmp file!!!\n");
						break;
					}
					printf("image get success\r\n");
				}
			}
				break;

			case '9':
			{
				uint8 ucImageInfo[128] = "";
				uint16 usImageWidth;
				uint16 usImageHeight;
				uint8 ucImageFormat;
				
				iRet = tx_scanner_get_image_info(ucImageInfo, sizeof(ucImageInfo));
				if(iRet < 0)
				{
					printf("tx_scanner_get_image_info fail!!!\r\n");
				}
				else
				{
					usImageWidth = (ucImageInfo[0] << 8) + ucImageInfo[1];
					usImageHeight = (ucImageInfo[2] << 8) + ucImageInfo[3];
					ucImageFormat = ucImageInfo[4];
					printf("Width:%d Height:%d Format:%d\r\n", usImageWidth, usImageHeight, ucImageFormat);
				}

			}
				break;

			case 'q':
			case 'Q':
				printf("quit\r\n");
				return 0;
				break;

			default:
				break;
		}
	}
	
	return 0;
}

static int32 tx_scanner_sdk_decode_data_cb(uint8 ucCodeType, uint8 *pBuf, uint32 uiBufLen)
{
	printf("[%03d][%02d]len:%d,data:%s\r\n", ++s_uiDecodeCnt, ucCodeType, uiBufLen, pBuf);

	return 0;
}

static void tx_scanner_sdk_comm_state_cb_fun(uint8 ucState)
{
	/**0:Ͽ,1:**/
	printf("scanner comm state:%d\r\n", ucState);
}

static int32 tx_scanner_sdk_save_raw(const char* pFilePath, const uint8* pImageData, int32 iImageSize) 
{
	FILE* file;
    if(fopen_s(&file, pFilePath, "wb") != 0)
	{
		return FAIL;
    } 
	else 
	{
		fwrite(pImageData, iImageSize, 1, file);/**дͼƬ**/
        fclose(file);
		return SUCC;
    }

}

static int32 tx_scanner_sdk_save_bmp(const char* pFilePath,uint8 *pImageData, int16 sImageWidth, int16 sImageHeight)
{
	int32 iImageSize = sImageWidth * sImageHeight;
	uint8 ucTempHead[54] = 
	  {   
	    0x42, 0x4d, 				/**file type**/
		0x0, 0x0, 0x0, 0x00, 		/**file size**/
		0x00, 0x00, 				/**reserved**/
		0x00, 0x00, 				/**reserved**/
		0x36, 0x4, 0x00, 0x00, 		/**head Offset byte**/
		/**infoheader**/
		0x28, 0x00, 0x00, 0x00, 	/**struct size**/
		0x00, 0x00, 0x00, 0x00, 	/**map width**/
		0x00, 0x00, 0x00, 0x00, 	/**map height**/
		0x01, 0x00, 				/**Planes must be 1**/
		0x08, 0x00, 				/**color count**/
		0x00, 0x00, 0x00, 0x00, 	/**compression**/
		0x00, 0x00, 0x00, 0x00, 	/**data size**/
		0x00, 0x00, 0x00, 0x00, 	/**dpix**/
		0x00, 0x00, 0x00, 0x00,	 	/**dpiy**/
		0x00, 0x00, 0x00, 0x00, 	/**color used**/
		0x00, 0x00, 0x00, 0x00, 	/**color important**/
	};
    uint8 ucHead[1078] = { 0 };
	uint8 *pNewBmp = (uint8*)malloc(1078+iImageSize);
	int32 i, j;
	long num;
	uint8 iRet = FAIL;
	
	memset(pNewBmp,0,1078+iImageSize);
    memcpy(ucHead,ucTempHead,sizeof(ucTempHead));
	
	num = sImageWidth;
	ucHead[18] = (uint8) (num & 0xFF);
	num = num >> 8;
	ucHead[19] = (uint8) (num & 0xFF);
	num = num >> 8;
	ucHead[20] = (uint8) (num & 0xFF);
	num = num >> 8;
	ucHead[21] = (uint8) (num & 0xFF);

	num = -sImageHeight;/**ͼĸ߶ȣֵһ˵ͼǵģֵһ˵ͼ**/
	ucHead[22] = (uint8) (num & 0xFF);
	num = num >> 8;
	ucHead[23] = (uint8) (num & 0xFF);
	num = num >> 8;
	ucHead[24] = (uint8) (num & 0xFF);
	num = num >> 8;
	ucHead[25] = (uint8) (num & 0xFF);

	j = 0;
	for(i=54;i<1078;i=i+4) 
	{
		ucHead[i] = ucHead[i+1] = ucHead[i+2] = (char) j;
		ucHead[i+3] = 0;
		j++;
	}
    memcpy(pNewBmp, ucHead, sizeof(ucHead));		
    memcpy(pNewBmp+1078, pImageData, iImageSize);	

	iRet = tx_scanner_sdk_bmp_write_data(pFilePath, pNewBmp, 1078+iImageSize);
	free(pNewBmp);
	
	return iRet;
}

static int32 tx_scanner_sdk_bmp_write_data(const char* pFilePath,uint8 *pImageData, int32 iBytes)
{
	HANDLE hFile;
	DWORD dwBytesWritten;

	hFile = CreateFile(pFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		return -1;  // ļʧ
	}

	if(!WriteFile(hFile, pImageData, iBytes, &dwBytesWritten, NULL)) 
	{
		CloseHandle(hFile);
		return -1;  // дʧ
	}

	CloseHandle(hFile);
 
	return 0;
}

