// stdafx.h : ׼ϵͳļİļ
// Ǿʹõĵ
// ضĿİļ
//

#pragma once

#include "targetver.h"

#include <stdio.h>
#include <tchar.h>



// TODO:  ڴ˴óҪͷļ
typedef unsigned char uint8;
typedef signed char int8;
typedef unsigned short uint16;
typedef signed short int16;
typedef unsigned int uint32;
typedef signed int int32;

#ifndef SUCC
#define SUCC	0
#endif

#ifndef FAIL
#define FAIL	-1
#endif

#define MIN(a, b) ((a) < (b) ? (a) : (b))



/**봥ʽ**/
typedef enum DB_TRIGGER_MODE_
{
	DB_TRIGGER_M_LEVEL = 0x00,	/**00[](ƽ)**/	//Ĭ
	DB_TRIGGER_M_PULSE, 		/**01[]()ΰģʽ**/
	DB_TRIGGER_M_CONTINUOUS,	/**02[]ģʽ**/
	DB_TRIGGER_M_AUTOSENS,		/**03[]ԶӦģʽ**/

}DB_TRIGGER_MODE_E;

/**LEDƵ״̬(λƺ)**/
typedef enum DB_LED_STATE_
{
	DB_LED_S_NORMAL = 0x00, 	/**ʱ**/
	DB_LED_S_ALWAYS_OFF,		/**һֱر**/
	DB_LED_S_ALWAYS_ON, 		/**һֱ**/

	DB_LED_S_MAX,
}DB_LED_STATE_E;

/**ڲ**/
typedef enum TS_UART_BAUDRATE_
{
	TS_BAUD_300 = 0x00,
	TS_BAUD_600,
	TS_BAUD_1200,
	TS_BAUD_2400,
	TS_BAUD_4800,
	TS_BAUD_9600,
	TS_BAUD_14400,
	TS_BAUD_19200,
	TS_BAUD_38400,
	TS_BAUD_57600,
	TS_BAUD_115200, /**Ĭ**/
	TS_BAUD_128000,
	TS_BAUD_192000,
	TS_BAUD_256000,

	TS_BAUD_MAX,
}TS_UART_BAUDRATE_E;

/**λ**/
typedef enum TS_UART_DATA_BITS_
{
	TS_DATA_BITS_5 = 0x00,
	TS_DATA_BITS_6,
	TS_DATA_BITS_7,
	TS_DATA_BITS_8, /**Ĭ**/

	TS_DATA_BITS_MAX,
}TS_UART_DATA_BITS_E;

/**ֹͣλ**/
typedef enum TS_UART_STOP_BITS_
{
	TS_STOP_BITS_1 = 0x00, /**Ĭ**/
	TS_STOP_BITS_1_5,	/**λ5λ**/
	TS_STOP_BITS_2,		/**λ6,7,8λ**/

	TS_STOP_BITS_MAX,
}TS_UART_STOP_BITS_E;

/**Уλ**/
typedef enum TS_UART_PARITY_BITS_
{
	TS_PARITY_BITS_NONE = 0x00, /**Ĭ**/
	TS_PARITY_BITS_ODD,
	TS_PARITY_BITS_EVEN,
	TS_PARITY_BITS_MARK,
	TS_PARITY_BITS_SPACE,

	TS_PARITY_BITS_MAX,
}TS_UART_PARITY_BITS_E;

/****/
typedef enum TS_UART_FLOW_CTL_
{
	TS_FW_NONE = 0x00, /**Ĭ**/
	TS_FW_HARDWARE,
	TS_FW_SOFTWARE,

	TS_FW_MAX,
}TS_UART_FLOW_CTL_E;

typedef struct TS_UART_
{
	uint8 ucCom[32];	/**ں**/
	TS_UART_BAUDRATE_E eBaudrate;	/****/
	TS_UART_DATA_BITS_E eDataBits;	/**λ**/
	TS_UART_STOP_BITS_E eStopBits;	/**ֹͣλ**/
	TS_UART_PARITY_BITS_E eParityBits;/**Уλ**/
	TS_UART_FLOW_CTL_E eFlowCtl;	/****/
}TS_UART_T;

/****/
typedef enum DB_HEARTBEAT_TYPE_
{
	DB_HEARTBEAT_T_DISABLE = 0x00,	/**ֹ, Ĭ**/
	DB_HEARTBEAT_T_NOT_ACK,			/**ҪACK**/
	DB_HEARTBEAT_T_NEED_ACK,		/**ҪACK**/

	DB_HEARTBEAT_T_MAX,
}DB_HEARTBEAT_TYPE_E;